Index: COPYING
===================================================================
--- COPYING	(revision 96316baecdf960a187a67af257d4699fa708b311)
+++ COPYING	(revision 96316baecdf960a187a67af257d4699fa708b311)
@@ -0,0 +1,44 @@
+*****************************************************************************
+                 Copyright (C) 2014, UChicago Argonne, LLC
+                          All Rights Reserved
+                     High-Performance CRC64 Library
+                   Developer: Hal Finkel, LCF Division
+
+                          OPEN SOURCE LICENSE
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are met:
+
+1. Redistributions of source code must retain the above copyright notice, this
+   list of conditions and the following disclaimer.  Software changes,
+   modifications, or derivative works, should be noted with comments and the
+   author and organization’s name.
+
+2. Redistributions in binary form must reproduce the above copyright notice,
+   this list of conditions and the following disclaimer in the documentation
+   and/or other materials provided with the distribution.
+
+3. Neither the names of UChicago Argonne, LLC or the Department of Energy nor
+   the names of its contributors may be used to endorse or promote products
+   derived from this software without specific prior written permission.
+
+4. The software and the end-user documentation included with the
+   redistribution, if any, must include the following acknowledgment:
+
+   "This product includes software produced by UChicago Argonne, LLC under
+    Contract No. DE-AC02-06CH11357 with the Department of Energy."
+
+*****************************************************************************
+                               DISCLAIMER
+
+THE SOFTWARE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND.
+
+NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT OF
+ENERGY, NOR UCHICAGO ARGONNE, LLC, NOR ANY OF THEIR EMPLOYEES, MAKES ANY
+WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY
+FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, DATA,
+APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
+INFRINGE PRIVATELY OWNED RIGHTS.
+
+*****************************************************************************
+
Index: include/CRC64.h
===================================================================
--- include/CRC64.h	(revision ccf520e5e9c2b196dc1e15e8547052e83822ef7f)
+++ include/CRC64.h	(revision 96316baecdf960a187a67af257d4699fa708b311)
@@ -1,3 +1,45 @@
-//                    Author: Hal Finkel
+// *****************************************************************************
+//                  Copyright (C) 2014, UChicago Argonne, LLC
+//                           All Rights Reserved
+//                      High-Performance CRC64 Library
+//                    Developer: Hal Finkel, LCF Division
+// 
+//                           OPEN SOURCE LICENSE
+// 
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+// 
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.  Software changes,
+//    modifications, or derivative works, should be noted with comments and the
+//    author and organization’s name.
+// 
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+// 
+// 3. Neither the names of UChicago Argonne, LLC or the Department of Energy nor
+//    the names of its contributors may be used to endorse or promote products
+//    derived from this software without specific prior written permission.
+// 
+// 4. The software and the end-user documentation included with the
+//    redistribution, if any, must include the following acknowledgment:
+// 
+//    "This product includes software produced by UChicago Argonne, LLC under
+//     Contract No. DE-AC02-06CH11357 with the Department of Energy."
+// 
+// *****************************************************************************
+//                                DISCLAIMER
+// 
+// THE SOFTWARE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND.
+// 
+// NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT OF
+// ENERGY, NOR UCHICAGO ARGONNE, LLC, NOR ANY OF THEIR EMPLOYEES, MAKES ANY
+// WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY
+// FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, DATA,
+// APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
+// INFRINGE PRIVATELY OWNED RIGHTS.
+// 
+// *****************************************************************************
 
 #ifndef CRC64_H
Index: src/CRC64.c
===================================================================
--- src/CRC64.c	(revision ccf520e5e9c2b196dc1e15e8547052e83822ef7f)
+++ src/CRC64.c	(revision 96316baecdf960a187a67af257d4699fa708b311)
@@ -1,3 +1,45 @@
-//                    Author: Hal Finkel
+// *****************************************************************************
+//                  Copyright (C) 2014, UChicago Argonne, LLC
+//                           All Rights Reserved
+//                      High-Performance CRC64 Library
+//                    Developer: Hal Finkel, LCF Division
+// 
+//                           OPEN SOURCE LICENSE
+// 
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+// 
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.  Software changes,
+//    modifications, or derivative works, should be noted with comments and the
+//    author and organization’s name.
+// 
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+// 
+// 3. Neither the names of UChicago Argonne, LLC or the Department of Energy nor
+//    the names of its contributors may be used to endorse or promote products
+//    derived from this software without specific prior written permission.
+// 
+// 4. The software and the end-user documentation included with the
+//    redistribution, if any, must include the following acknowledgment:
+// 
+//    "This product includes software produced by UChicago Argonne, LLC under
+//     Contract No. DE-AC02-06CH11357 with the Department of Energy."
+// 
+// *****************************************************************************
+//                                DISCLAIMER
+// 
+// THE SOFTWARE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND.
+// 
+// NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT OF
+// ENERGY, NOR UCHICAGO ARGONNE, LLC, NOR ANY OF THEIR EMPLOYEES, MAKES ANY
+// WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY
+// FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, DATA,
+// APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
+// INFRINGE PRIVATELY OWNED RIGHTS.
+// 
+// *****************************************************************************
 
 #ifndef __STDC_CONSTANT_MACROS
Index: tests/CRC64Test.cxx
===================================================================
--- tests/CRC64Test.cxx	(revision ccf520e5e9c2b196dc1e15e8547052e83822ef7f)
+++ tests/CRC64Test.cxx	(revision 96316baecdf960a187a67af257d4699fa708b311)
@@ -1,3 +1,45 @@
-//                    Author: Hal Finkel
+// *****************************************************************************
+//                  Copyright (C) 2014, UChicago Argonne, LLC
+//                           All Rights Reserved
+//                      High-Performance CRC64 Library
+//                    Developer: Hal Finkel, LCF Division
+// 
+//                           OPEN SOURCE LICENSE
+// 
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+// 
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.  Software changes,
+//    modifications, or derivative works, should be noted with comments and the
+//    author and organization’s name.
+// 
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+// 
+// 3. Neither the names of UChicago Argonne, LLC or the Department of Energy nor
+//    the names of its contributors may be used to endorse or promote products
+//    derived from this software without specific prior written permission.
+// 
+// 4. The software and the end-user documentation included with the
+//    redistribution, if any, must include the following acknowledgment:
+// 
+//    "This product includes software produced by UChicago Argonne, LLC under
+//     Contract No. DE-AC02-06CH11357 with the Department of Energy."
+// 
+// *****************************************************************************
+//                                DISCLAIMER
+// 
+// THE SOFTWARE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND.
+// 
+// NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT OF
+// ENERGY, NOR UCHICAGO ARGONNE, LLC, NOR ANY OF THEIR EMPLOYEES, MAKES ANY
+// WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY
+// FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, DATA,
+// APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
+// INFRINGE PRIVATELY OWNED RIGHTS.
+// 
+// *****************************************************************************
 
 #define _XOPEN_SOURCE 600